"""
    The Plaid API

    The Plaid REST API. Please see https://plaid.com/docs/api for more details.  # noqa: E501
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from plaid.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from plaid.model.asset_transaction_category_type import AssetTransactionCategoryType
    from plaid.model.asset_transaction_type import AssetTransactionType
    globals()['AssetTransactionCategoryType'] = AssetTransactionCategoryType
    globals()['AssetTransactionType'] = AssetTransactionType


class AssetTransactionDetail(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'asset_transaction_unique_identifier': (str,),  # noqa: E501
            'asset_transaction_amount': (float,),  # noqa: E501
            'asset_transaction_date': (date,),  # noqa: E501
            'asset_transaction_post_date': (date,),  # noqa: E501
            'asset_transaction_type': (AssetTransactionType,),  # noqa: E501
            'asset_transaction_paid_by_name': (str, none_type,),  # noqa: E501
            'asset_transaction_type_additional_description': (str, none_type,),  # noqa: E501
            'asset_transaction_category_type': (AssetTransactionCategoryType,),  # noqa: E501
            'financial_institution_transaction_identifier': (str, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'asset_transaction_unique_identifier': 'AssetTransactionUniqueIdentifier',  # noqa: E501
        'asset_transaction_amount': 'AssetTransactionAmount',  # noqa: E501
        'asset_transaction_date': 'AssetTransactionDate',  # noqa: E501
        'asset_transaction_post_date': 'AssetTransactionPostDate',  # noqa: E501
        'asset_transaction_type': 'AssetTransactionType',  # noqa: E501
        'asset_transaction_paid_by_name': 'AssetTransactionPaidByName',  # noqa: E501
        'asset_transaction_type_additional_description': 'AssetTransactionTypeAdditionalDescription',  # noqa: E501
        'asset_transaction_category_type': 'AssetTransactionCategoryType',  # noqa: E501
        'financial_institution_transaction_identifier': 'FinancialInstitutionTransactionIdentifier',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, asset_transaction_unique_identifier, asset_transaction_amount, asset_transaction_date, asset_transaction_post_date, asset_transaction_type, asset_transaction_paid_by_name, asset_transaction_type_additional_description, asset_transaction_category_type, financial_institution_transaction_identifier, *args, **kwargs):  # noqa: E501
        """AssetTransactionDetail - a model defined in OpenAPI

        Args:
            asset_transaction_unique_identifier (str): A vendor creadted unique Identifier.
            asset_transaction_amount (float): AssetTransactionAmountName.
            asset_transaction_date (date): Asset Transaction Date.
            asset_transaction_post_date (date): Asset Transaction Post Date.
            asset_transaction_type (AssetTransactionType):
            asset_transaction_paid_by_name (str, none_type): Populate with who did the transaction.
            asset_transaction_type_additional_description (str, none_type): FI Provided - examples are atm, cash, check, credit, debit, deposit, directDebit, directDeposit, dividend, fee, interest, other, payment, pointOfSale, repeatPayment, serviceCharge, transfer.
            asset_transaction_category_type (AssetTransactionCategoryType):
            financial_institution_transaction_identifier (str, none_type): FI provided Transaction Identifier.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.asset_transaction_unique_identifier = asset_transaction_unique_identifier
        self.asset_transaction_amount = asset_transaction_amount
        self.asset_transaction_date = asset_transaction_date
        self.asset_transaction_post_date = asset_transaction_post_date
        self.asset_transaction_type = asset_transaction_type
        self.asset_transaction_paid_by_name = asset_transaction_paid_by_name
        self.asset_transaction_type_additional_description = asset_transaction_type_additional_description
        self.asset_transaction_category_type = asset_transaction_category_type
        self.financial_institution_transaction_identifier = financial_institution_transaction_identifier
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
