"""
    The Plaid API

    The Plaid REST API. Please see https://plaid.com/docs/api for more details.  # noqa: E501
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from plaid.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from plaid.model.income_verification_source_type import IncomeVerificationSourceType
    from plaid.model.link_token_create_request_income_verification_bank_income import LinkTokenCreateRequestIncomeVerificationBankIncome
    from plaid.model.link_token_create_request_income_verification_payroll_income import LinkTokenCreateRequestIncomeVerificationPayrollIncome
    from plaid.model.link_token_create_request_user_stated_income_source import LinkTokenCreateRequestUserStatedIncomeSource
    globals()['IncomeVerificationSourceType'] = IncomeVerificationSourceType
    globals()['LinkTokenCreateRequestIncomeVerificationBankIncome'] = LinkTokenCreateRequestIncomeVerificationBankIncome
    globals()['LinkTokenCreateRequestIncomeVerificationPayrollIncome'] = LinkTokenCreateRequestIncomeVerificationPayrollIncome
    globals()['LinkTokenCreateRequestUserStatedIncomeSource'] = LinkTokenCreateRequestUserStatedIncomeSource


class LinkTokenCreateRequestIncomeVerification(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'income_verification_id': (str,),  # noqa: E501
            'asset_report_id': (str,),  # noqa: E501
            'precheck_id': (str,),  # noqa: E501
            'access_tokens': ([str],),  # noqa: E501
            'income_source_types': ([IncomeVerificationSourceType],),  # noqa: E501
            'bank_income': (LinkTokenCreateRequestIncomeVerificationBankIncome,),  # noqa: E501
            'payroll_income': (LinkTokenCreateRequestIncomeVerificationPayrollIncome,),  # noqa: E501
            'stated_income_sources': ([LinkTokenCreateRequestUserStatedIncomeSource],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'income_verification_id': 'income_verification_id',  # noqa: E501
        'asset_report_id': 'asset_report_id',  # noqa: E501
        'precheck_id': 'precheck_id',  # noqa: E501
        'access_tokens': 'access_tokens',  # noqa: E501
        'income_source_types': 'income_source_types',  # noqa: E501
        'bank_income': 'bank_income',  # noqa: E501
        'payroll_income': 'payroll_income',  # noqa: E501
        'stated_income_sources': 'stated_income_sources',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """LinkTokenCreateRequestIncomeVerification - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            income_verification_id (str): The `income_verification_id` of the verification instance, as provided by `/income/verification/create`.. [optional]  # noqa: E501
            asset_report_id (str): The `asset_report_id` of an asset report associated with the user, as provided by `/asset_report/create`. Providing an `asset_report_id` is optional and can be used to verify the user through a streamlined flow. If provided, the bank linking flow will be skipped.. [optional]  # noqa: E501
            precheck_id (str): The ID of a precheck created with `/income/verification/precheck`. Will be used to improve conversion of the income verification flow by streamlining the Link interface presented to the end user.. [optional]  # noqa: E501
            access_tokens ([str]): An array of access tokens corresponding to Items that a user has previously connected with. Data from these institutions will be cross-referenced with document data received during the Document Income flow to help verify that the uploaded documents are accurate. If the `transactions` product was not initialized for these Items during link, it will be initialized after this Link session.  This field should only be used with the `payroll` income source type.. [optional]  # noqa: E501
            income_source_types ([IncomeVerificationSourceType]): The types of source income data that users will be permitted to share. Options include `bank` and `payroll`. Currently you can only specify one of these options.. [optional]  # noqa: E501
            bank_income (LinkTokenCreateRequestIncomeVerificationBankIncome): [optional]  # noqa: E501
            payroll_income (LinkTokenCreateRequestIncomeVerificationPayrollIncome): [optional]  # noqa: E501
            stated_income_sources ([LinkTokenCreateRequestUserStatedIncomeSource]): A list of user stated income sources. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
